Foxit PDF SDK

Instance Methods | List of all members
FSLayerNode Class Reference
Inheritance diagram for FSLayerNode:

## Instance Methods
(FSLayerNode *) | - addChild:name:has_Layer:
| Add a new layer node as a child for current layer node. More...
(BOOL) | - addGraphicsObject:graphicsobject:
| Add a graphics object to current layer node. More...
(FSAnnotArray *) | - getAnnots
| Get an array of annotations which are related to current layer node. More...
(FSLayerNode *) | - getChild:
| Get a child node. More...
(int) | - getChildrenCount
| Get the count of children nodes. More...
(FSPDFDictionary *) | - getDict
| Get the PDF dictionary of current object. More...
(FSLayerTreeUsageState) | - getExportUsage
| Get the state for exporting usage. More...
(FSGraphicsObjectArray *) | - getGraphicsObjects:
| Get all graphics objects related to the layer which is associated with current layer node. More...
(NSString *) | - getName
| Get the name of current layer node. More...
(FSLayerPrintData *) | - getPrintUsage
| Get the data for printing usage. More...
(FSLayerTreeUsageState) | - getViewUsage
| Get the state for viewing usage. More...
(FSLayerZoomData *) | - getZoomUsage
| Get the data for zooming usage. More...
(BOOL) | - hasIntent:
| Check if current layer node has a specified intent. More...
(BOOL) | - hasLayer
| Check if current layer node is associated with a layer. More...
(id) | - initWithOther:
| Constructor, with another layer node object. More...
(BOOL) | - isEmpty
| Check whether current object is empty or not. More...
(BOOL) | - isInPage:
| Check if current layer node is in a specified PDF page. More...
(BOOL) | - isLocked
| Check if current layer node is locked. More...
(BOOL) | - moveTo:index:
| Move current layer node to be one of the children of another layer node. More...
(BOOL) | - removeChild:
| Remove a child node by index. More...
(BOOL) | - removeGraphicsObject:
| Remove a graphics object from current layer node. More...
(BOOL) | - removeUsage:
| Remove a kind of usage property. More...
(BOOL) | - setDefaultVisible:
| Set default visibility. More...
(BOOL) | - setExportUsage:
| Set state for exporting usage. More...
(BOOL) | - setName:
| Set the name of current layer node. More...
(BOOL) | - setPrintUsage:
| Set data for layer printing usage. More...
(BOOL) | - setViewUsage:
| Set state for viewing usage. More...
(BOOL) | - setZoomUsage:
| Set data for layer zooming usage. More...

## Detailed Description

A PDF layer (known as "Optional content group" in <PDF reference 1.7>) is a collection of graphics (known as FSGraphicsObject in Foxit PDF SDK) that can be made visible or invisible. These graphics belonging to the same layer can reside anywhere in the document: they need not be consecutive in drawing order, nor even belong to the same content stream.
In Foxit PDF SDK, a PDF layer is associated with a layer node and Foxit PDF SDK offers class and methods to get/set layer data via layer node. If user wants to retrieve a layer node, user must construct a layer tree object first and then call function FSLayerTree::getRootNode to get the root layer node of the whole layer tree. Here, "root layer node" is an abstract object. "root layer node" can only have some child layer nodes but no parent, or any data (such as name, intent and so on). And "root layer node" cannot be shown on the application UI since it has no data. So, for a root layer node, only functions FSLayerNode::getChildrenCount and FSLayerNode::getChild: are useful.
This class offers functions to get/set layer data and the graphics belonging to it. For example:

- To get/set layer data, following functions can be used: FSLayerNode::getName, FSLayerNode::getViewUsage, FSLayerNode::getExportUsage, FSLayerNode::getPrintUsage, FSLayerNode::getZoomUsage and setting functions for these data.
- To get the graphics belonging to it, use function FSLayerNode::getGraphicsObjects:; function FSLayerNode::addGraphicsObject:graphicsobject: and FSLayerNode::removeGraphicsObject: can be used to add/remove a specified graphics object to/from the layer.

See also
  FSLayerTree

## Method Documentation

## ◆ addChild:name:has_Layer:()

- (FSLayerNode *) addChild: |  | (int) | index
name: |  | (NSString *) | name
has_Layer: |  | (BOOL) | has_Layer

Add a new layer node as a child for current layer node.

Parameters

  [in] | index | Child index for the new child layer node. Valid range: from 0 to count. count means to be the last child of current layer node and is returned by function FSLayerNode::getChildrenCount for current layer node.
  [in] | name | Name for the new layer node. It should not be an empty string.
  [in] | has_Layer | YES means the new child layer node would be associated with a layer, and NO means the new child layer node is not associated with a layer.

Returns
  A layer node object that specifies the new child layer node.

## ◆ addGraphicsObject:graphicsobject:()

- (BOOL) addGraphicsObject: |  | (FSPDFPage*) | page
graphicsobject: |  | (FSGraphicsObject*) | graphicsobject

Add a graphics object to current layer node.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Parameters

  [in] | page | A valid PDF page, to which the input graphics object belongs.
  [in] | graphicsobject | A graphics object to be added to current layer node.

Returns
  YES means success, while NO means failure.

## ◆ getAnnots()

- (FSAnnotArray *) getAnnots |  |  |

Get an array of annotations which are related to current layer node.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will return an empty array directly.

Returns
  An array of annotations.

## ◆ getChild:()

- (FSLayerNode *) getChild: |  | (int) | index |

Get a child node.

Parameters

  [in] | index | Index of the child to be retrieved. Valid range: from 0 to (count-1). count is returned by function FSLayerNode::getChildrenCount.

Returns
  A child layer node object.

## ◆ getChildrenCount()

- (int) getChildrenCount |  |  |

Get the count of children nodes.

Returns
  The count of children nodes.

## ◆ getDict()

- (FSPDFDictionary *) getDict |  |  |

Get the PDF dictionary of current object.

Note
  Please refer to "Optional Content Groups" in <PDF Reference 1.7> P364 for more details.

Returns
  The PDF dictionary. If FSLayerNode::hasLayer of current layer node returns NO, this function will return nil.

## ◆ getExportUsage()

- (FSLayerTreeUsageState) getExportUsage |  |  |

Get the state for exporting usage.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Returns
  Layer usage state. Please refer to values starting from FSLayerTreeStateON and this would be one of these values except FSLayerTreeStateUnchanged.

## ◆ getGraphicsObjects:()

- (FSGraphicsObjectArray *) getGraphicsObjects: |  | (FSPDFPage*) | page |

Get all graphics objects related to the layer which is associated with current layer node.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Parameters

  [in] | page | A valid PDF page, to which the input graphics object belongs.

Returns
  A graphics object array which contains related graphic objects.

## ◆ getName()

- (NSString *) getName |  |  |

Get the name of current layer node.

Returns
  Layer node name.

## ◆ getPrintUsage()

- (FSLayerPrintData *) getPrintUsage |  |  |

Get the data for printing usage.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Returns
  Data for layer printing usage.

## ◆ getViewUsage()

- (FSLayerTreeUsageState) getViewUsage |  |  |

Get the state for viewing usage.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Returns
  Layer usage state. Please refer to values starting from FSLayerTreeStateON and this would be one of these values except FSLayerTreeStateUnchanged.

## ◆ getZoomUsage()

- (FSLayerZoomData *) getZoomUsage |  |  |

Get the data for zooming usage.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Returns
  Data for layer zooming usage.

## ◆ hasIntent:()

- (BOOL) hasIntent: |  | (NSString *) | intent |

Check if current layer node has a specified intent.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.
Specially, when this function with input parameter "View" returns NO, that means the layer related to current layer node will always be visible, and will not be affected by the changing in visibility.

Parameters

  [in] | intent | Intent name to be checked. It should not be an empty string. Pre-defined intent names are "View" and "Design".

Returns
  YES means current layer node has the specified intent, while NO means current layer node does not the specified intent.

## ◆ hasLayer()

- (BOOL) hasLayer |  |  |

Check if current layer node is associated with a layer.

Returns
  YES means current layer node is associated with a layer, while NO means current layer node is not associated with a layer.

## ◆ initWithOther:()

- (id) initWithOther: |  | (FSLayerNode*) | other |

Constructor, with another layer node object.

Parameters

  [in] | other | Another layer node object.

## ◆ isEmpty()

- (BOOL) isEmpty |  |  |

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  YES means current object is empty, while NO means not.

## ◆ isInPage:()

- (BOOL) isInPage: |  | (FSPDFPage*) | page |

Check if current layer node is in a specified PDF page.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Parameters

  [in] | page | A valid PDF page.

Returns
  YES means current layer node is in the specified PDF page, while NO means current layer node is not in the specified PDF page.

## ◆ isLocked()

- (BOOL) isLocked |  |  |

Check if current layer node is locked.

Returns
  YES means current layer node is locked, while NO means current layer node is not locked.

## ◆ moveTo:index:()

- (BOOL) moveTo: |  | (FSLayerNode*) | parent_layer_node
index: |  | (int) | index

Move current layer node to be one of the children of another layer node.

Parameters

  [in] | parent_layer_node | The destination layer node. It should not be current layer node itself or any descendant of current layer node. Current layer node will be moved to be one of the children of the destination layer node.
  [in] | index | Child index which specifies where current layer node will be moved as a child of destination layer node. Valid range: from 0 to count. count means to be the last child of destination layer node and is returned by function FSLayerNode::getChildrenCount for parameter parent_layer_node.

Returns
  YES means success, while NO means failure.

## ◆ removeChild:()

- (BOOL) removeChild: |  | (int) | index |

Remove a child node by index.

Parameters

  [in] | index | Index of the child node to be removed. Valid range: from 0 to (count-1). count is returned by function FSLayerNode::getChildrenCount.

Returns
  YES means success, while NO means failure.

## ◆ removeGraphicsObject:()

- (BOOL) removeGraphicsObject: |  | (FSGraphicsObject*) | graphics_object |

Remove a graphics object from current layer node.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.
If the input graphics object does not belong to current layer node, this function will return YES directly.

Parameters

  [in] | graphics_object | A graphics object to be removed from current layer node.

Returns
  YES means success, while NO means failure.

## ◆ removeUsage:()

- (BOOL) removeUsage: |  | (FSLayerContextUsageType) | usage_type |

Remove a kind of usage property.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.
If current layer node does not have the specified usage or does not have any usage, this function will return YES.

Parameters

  [in] | usage_type | Layer usage type to be removed. Please refer to values starting from FSLayerContextUsageView and this should be one of these values.

Returns
  YES means success, while NO means failure.

## ◆ setDefaultVisible:()

- (BOOL) setDefaultVisible: |  | (BOOL) | is_visible |

Set default visibility.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Parameters

  [in] | is_visible | YES means visible, and NO means invisible.

Returns
  YES means success, while NO means failure.

## ◆ setExportUsage:()

- (BOOL) setExportUsage: |  | (FSLayerTreeUsageState) | state |

Set state for exporting usage.

If user wants the new state to have effect on rendering result, please construct a new layer context object after this function succeeds, and then use the new layer context object to Renderer to do rendering.
This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Parameters

  [in] | state | Layer usage state. It should be one of following values: FSLayerTreeStateON FSLayerTreeStateOFF FSLayerTreeStateUndefined means to remove this property from current layer node

Returns
  YES means success, while NO means failure.

## ◆ setName:()

- (BOOL) setName: |  | (NSString *) | name |

Set the name of current layer node.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Parameters

  [in] | name | New layer node name. It should not be an empty string.

Returns
  YES means success, while NO means failure.

## ◆ setPrintUsage:()

- (BOOL) setPrintUsage: |  | (FSLayerPrintData*) | data |

Set data for layer printing usage.

If user wants the new state to have effect on rendering result, please construct a new layer context object after this function succeeds, and then use the new layer context object to Renderer to do rendering.
This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Parameters

  [in] | data | New data for layer printing usage. The value of print state of input data should be one of following values: FSLayerTreeStateON FSLayerTreeStateOFF FSLayerTreeStateUndefined means to remove this property from current layer node

Returns
  YES means success, while NO means failure.

## ◆ setViewUsage:()

- (BOOL) setViewUsage: |  | (FSLayerTreeUsageState) | state |

Set state for viewing usage.

If user wants the new state to have effect on rendering result, please construct a new layer context object after this function succeeds, and then use the new layer context object to Renderer to do rendering.
This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Parameters

  [in] | state | Layer usage state. It should be one of following values: FSLayerTreeStateON FSLayerTreeStateOFF FSLayerTreeStateUndefined means to remove this property from current layer node

Returns
  YES means success, while NO means failure.

## ◆ setZoomUsage:()

- (BOOL) setZoomUsage: |  | (FSLayerZoomData*) | data |

Set data for layer zooming usage.

This function can only be used when function FSLayerNode::hasLayer returns YES. If current layer node does not have layer, this function will throw exception FSErrUnsupported.

Parameters

  [in] | data | New data for layer zooming usage.

Returns
  YES means success, while NO means failure.